#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"

int ML_ItemIsRelease(EPM_action_message_t msg)
{
	printf("=========================判断文件夹下对象是否发布 Start===================\n");
	auto startTime = std::chrono::high_resolution_clock::now();
	int ifail = ITK_ok;
	int  attachments_num = 0;
	tag_t  rootTask = NULLTAG, *attachments = NULLTAG;
	//获取任务对象
	EPM_ask_root_task(msg.task, &rootTask);
	//获取任务目标对象
	EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments);
	bool isNull = true;
	char *argflag = NULL, *argvalue = NULL, *arg = NULL;
	char arg1value[1024] = "", arg2value[1024] = "", arg3value[1024] = "", releaseStatus[1024] = "";
	//获取参数
	int arg_cnt = TC_number_of_arguments(msg.arguments);
	printf("参数个数为：%d\n", arg_cnt);
	if (arg_cnt > 0)
	{
		for (int i = 0; i<arg_cnt; i++)
		{
			//获取下一个参数（从0开始）
			arg = TC_next_argument(msg.arguments);
			//获取参数的名称和值
			ifail = ITK_ask_argument_named_value((const char*)arg, &argflag, &argvalue);
			if (stricmp(argflag, "itemType") == 0)
			{
				//strcmp("","");
				if (argvalue != NULL)
				{
					strcpy(arg1value, argvalue);
				}
			}
			else if (stricmp(argflag, "referenced") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(arg2value, argvalue);
				}
			}
			else if (stricmp(argflag, "checkItemType") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(arg3value, argvalue);
				}
			}
			else if (stricmp(argflag, "releaseStatus") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(releaseStatus, argvalue);
				}
			}
			else if (stricmp(argflag, "isNull") == 0)
			{
				isNull = false;
			}
		}
		DOFREE(argflag);
		DOFREE(argvalue);
		DOFREE(arg);
	}

	vector<char *> itemTypeValues;

	if (strstr(arg1value, ",") != NULL)
	{
		int vectorValueCount = 0;
		char ** vectorValueChar = new char *[64];
		split(arg1value, ",", vectorValueChar, &vectorValueCount);
		for (int i = 0; i < vectorValueCount; i++)
		{
			itemTypeValues.push_back(vectorValueChar[i]);
		}
	}
	else
	{
		itemTypeValues.push_back(arg1value);
	}

	vector<char *> referencedValues;

	if (strstr(arg2value, ",") != NULL)
	{
		int vectorValueCount = 0;
		char ** vectorValueChar = new char *[64];
		split(arg2value, ",", vectorValueChar, &vectorValueCount);
		for (int i = 0; i < vectorValueCount; i++)
		{
			referencedValues.push_back(vectorValueChar[i]);
		}
	}
	else
	{
		referencedValues.push_back(arg2value);
	}

	vector<char *> checkItemTypeValues;

	if (strstr(arg3value, ",") != NULL)
	{
		int vectorValueCount = 0;
		char ** vectorValueChar = new char *[64];
		split(arg3value, ",", vectorValueChar, &vectorValueCount);
		for (int i = 0; i < vectorValueCount; i++)
		{
			checkItemTypeValues.push_back(vectorValueChar[i]);
		}
	}
	else
	{
		checkItemTypeValues.push_back(arg3value);
	}

	vector<char *> referenceValues;

	if (strstr(releaseStatus, ",") != NULL)
	{
		int vectorValueCount = 0;
		char ** vectorValueChar = new char *[64];
		split(releaseStatus, ",", vectorValueChar, &vectorValueCount);
		for (int i = 0; i < vectorValueCount; i++)
		{
			referenceValues.push_back(vectorValueChar[i]);
		}
	}
	else
	{
		referenceValues.push_back(releaseStatus);
	}

	char resultString[2048] = "";
	for (int i = 0; i < attachments_num; i++)
	{
		char *itemType = NULL;

		AOM_ask_value_string(attachments[i], "object_type", &itemType);
		printf("type_class : %s \r\n", itemType);
		//过滤掉非文件夹的对象
		if (!count(itemTypeValues, itemType))
		{
			DOFREE(itemType);
			continue;
		}
		//判断文件下的对象是否发布
		//AOM_ask_value_tags(attachments[i], arg2value, &num, &tags);
		for (auto referencedValue : referencedValues) {
			int num = 0;
			tag_t * tags = NULLTAG;
			AOM_ask_value_tags(attachments[i], referencedValue, &num, &tags);
			if (num <= 0 && isNull)
			{
				ifail = 2;
				if (strcmp(arg1value, "Folder") == 0)
				{
					strcat(resultString, "没有提交交付物，无法完成任务！");
					strcat(resultString, "\n");
				}
				else
				{
					strcat(resultString, referencedValue);
					strcat(resultString, "关系下不包含任何对象！");
					strcat(resultString, "\n");
				}
			}
			else
			{
				for (int j = 0; j < num; j++)
				{
					char *objectType = NULL;

					AOM_ask_value_string(tags[j], "object_type", &objectType);
					printf("objectType : %s \r\n", objectType);
					if (strcmp(arg3value, "") != 0)
					{
						if (!count(checkItemTypeValues, objectType))
						{
							DOFREE(objectType);
							continue;
						}
					}
					tag_t revisions = tags[j];
					if (strstr(objectType, "Revision") == NULL)
					{
						ITEM_ask_latest_rev(tags[j], &revisions);
					}
					int releaseCount = 0;
					tag_t * releaseTags = NULL;
					//判断子件是否发布
					AOM_ask_value_tags(revisions, "release_status_list", &releaseCount, &releaseTags);

					char *itemString = NULL;

					AOM_ask_value_string(revisions, "object_string", &itemString);

					bool isHave = false;
					for (int kk = 0; kk < releaseCount; kk++)
					{
						char * releaseString = NULL;
						AOM_ask_value_string(releaseTags[kk], "object_name", &releaseString);

						printf("releaseString : %s \r\n", releaseString);
						if (count(referenceValues, releaseString))
						{
							isHave = true;
							DOFREE(releaseString);
							break;
						}
						DOFREE(releaseString);
					}

					/*for (auto referencedValue : referenceValues) {

						if (strstr(releaseString, referencedValue) != NULL)
						{
							isHave = true;
							break;
						}
					}*/
					if (releaseCount == 0 || !isHave)
					{
						strcat(resultString, itemString);
						strcat(resultString, "\n");
						ifail = 1;
					}
					DOFREE(itemString);
					DOFREE(releaseTags);
					DOFREE(objectType);
				}
			}
			DOFREE(tags);
		}
		DOFREE(itemType);
	}
	itemTypeValues.clear();
	vector<char *>().swap(itemTypeValues);
	referencedValues.clear();
	vector<char *>().swap(referencedValues);
	checkItemTypeValues.clear();
	vector<char *>().swap(checkItemTypeValues);
	DOFREE(attachments); 
	if (ifail == 1)
	{
		strcat(resultString, "未发布或发布状态不正确！");
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, resultString);
	}
	else if (ifail == 2)
	{
		ifail = 1;
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, resultString);
	}

	auto stopTime = std::chrono::high_resolution_clock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(stopTime - startTime);
	//std::cout << "ML_ItemIsRelease用时:" << duration.count() / 1000 << std::endl;
	string usetime = "ML_ItemIsRelease用时:";
	usetime.append(std::to_string(duration.count() / 1000));
	WriteLog(true, usetime.c_str());
	printf("=========================判断文件夹下对象是否发布 End===================\n");
	return ifail;
}